<?php
/**
 * @file
 * Functions to propagate entity field's data.
 */

/**
 * Implements hook_data_propagation().
 */
function translation_field_diffuser_data_propagation($entity, $type) {
  if ($type == 'node') {
    $lang = property_exists($entity, 'language') ? $entity->language : language_default('language');
    $propagable_fields = property_exists($entity, 'propagable_fields') ? $entity->propagable_fields : array();

    $fields_to_propagate = array();
    foreach ($propagable_fields as $field_name) {
      $done = FALSE;

      if (property_exists($entity, $field_name)) {
        $field = $entity->{$field_name};
        $field_dlang = isset($field[$lang]) ? $field[$lang] : $field[LANGUAGE_NONE];

        foreach ($field_dlang as $item) {
          // At least one delta item has its data to propagate.
          if (!$done && isset($item['translation_field_diffuser_' . $field_name])
            && $item['translation_field_diffuser_' . $field_name]) {
            $fields_to_propagate[] = $field_name;
            $done = TRUE;
          }
        }
      }
    }

    // Update nodes with non default language.
    if (!empty($fields_to_propagate)) {
      $query = db_select('node', 'n')
        ->condition('n.nid', $entity->nid, '!=')
        ->condition('n.tnid', $entity->nid);
      $query->addField('n', 'nid');

      $result = $query->execute()->fetchAll();
      foreach ($result as $row) {
        if ($node_to_update = node_load($row->nid)) {
          foreach ($fields_to_propagate as $field_name) {
            $node_to_update->{$field_name} = $entity->{$field_name};
          }

          node_save($node_to_update);
        }
      }
    }
  }
}
